<template>
  <div>
    <b-modal
      id="mergeUserModalV2"
      :title="
        $t('page.userprofile.mergeModalV2.title', {
          provider: externalAuthName,
        })
      "
      :hide-footer="true"
      :static="true"
      :lazy="true"
    >
      <!-- Body -->
      <i18n-t tag="p" keypath="page.userprofile.mergeModalV2.body">
        <template #provider>
          <b>{{ externalAuthName }}</b>
        </template>
        <template #tokenDisclaimer>
          <b>
            {{
              $t("page.userprofile.mergeModalV2.tokenDisclaimer", {
                provider: externalAuthName,
              })
            }}
          </b>
        </template>
        <template #br>
          <br />
        </template>
      </i18n-t>

      <br />
      <span>
        {{ $t("page.userprofile.mergeModalV2.ready") }}
      </span>

      <!-- Buttons -->
      <div class="mt-3">
        <!-- Confirm Button -->
        <b-button
          id="logInForMerge"
          class="mergeUserModalRightBtn float-end"
          variant="primary"
          @click="proceedWithMerge"
        >
          {{ $t("nav.userLogIn") }}
        </b-button>

        <!-- Cancel Button -->
        <b-button
          class="mergeUserModalLeftBtn"
          variant="secondary"
          @click="mergeUserModalV2.hide()"
        >
          {{ $t("buttons.cancel") }}
        </b-button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts">
import { useModal } from "bootstrap-vue-next";
import useLoginStore from "@/modules/login/store";
import useMainStore from "@/store/index";

export default defineComponent({
  props: {
    externalAuthName: {
      default: null,
      type: String as PropType<string | null>,
    },
    externalAuthId: {
      default: null,
      type: String as PropType<string | null>,
    },
  },
  setup() {
    const mergeUserModalV2 = useModal("mergeUserModalV2");
    const loginStore = useLoginStore();
    const mainStore = useMainStore();

    return { mergeUserModalV2: mergeUserModalV2, loginStore, mainStore };
  },
  methods: {
    async proceedWithMerge() {
      if (this.externalAuthId) {
        const url = new URL(window.location.href);
        url.pathname = `/coscine/api/v2/self/session/merge/${this.externalAuthId}`;

        if (this.loginStore.isCookieLogin) {
          window.location.href = url.toString();
        } else {
          url.searchParams.append(
            "access_token",
            this.loginStore.authorization.bearer,
          );

          window.location.href = url.toString();
        }
      }
    },
  },
});
</script>

<style scoped></style>
